#include <bfm.h>
#include <bfm_qdp.h>

Set &GetTimeslice(void)
{
  if ( !timeslice_is_made )
    timeslice.make(TSliceFunc(Nd-1));
  return timeslice;
}

// Explicit template instantiations.
// Internal interfaces
template int dwf_invert<float> (multi1d<LatticeFermion> &sol, 
				multi1d<LatticeFermion> &src, 
				multi1d<LatticeColorMatrix> &U,
				std::string output_stem, 
				int Ls, Real mass, Real M5, Real residual, int max_iter);
// Internal interfaces
template int dwf_invert<double> (multi1d<LatticeFermion> &sol, 
				 multi1d<LatticeFermion> &src, 
				 multi1d<LatticeColorMatrix> &U,
				 std::string output_stem, 
				 int Ls, Real mass, Real M5, Real residual, int max_iter);

// Internal interfaces
template int dwf_restarted_invert<float,double> (multi1d<LatticeFermion> &sol, 
						 multi1d<LatticeFermion> &src, 
						 multi1d<LatticeColorMatrix> &U,
						 std::string output_stem, 
						 int Ls, Real mass, Real M5, int Ncg, Real residual[], int max_iter[]);

// Internal interfaces
template int dwf_restarted_invert<float,float> (multi1d<LatticeFermion> &sol, 
						 multi1d<LatticeFermion> &src, 
						 multi1d<LatticeColorMatrix> &U,
						 std::string output_stem, 
						int Ls, Real mass, Real M5, int Ncg, Real residual[], int max_iter[]);

// Internal interfaces
template int dwf_restarted_invert<double,double> (multi1d<LatticeFermion> &sol, 
						  multi1d<LatticeFermion> &src, 
						  multi1d<LatticeColorMatrix> &U,
						  std::string output_stem, 
						  int Ls, Real mass, Real M5, int Ncg, Real residual[], int max_iter[]);

template 
int dwf_CG<float,double>
           (LatticePropagator &sol, 
	    LatticePropagator &src,
	    multi1d<LatticeColorMatrix> &U,
	    std::string output_stem,
	    int Ls,
	    int do5d,
	    Real mass,
	    Real M5,int Ncg,Real residual[],int max_iter[]);

template 
int dwf_CG<double,double>
           (LatticePropagator &sol, 
	    LatticePropagator &src,
	    multi1d<LatticeColorMatrix> &U,
	    std::string output_stem,
	    int Ls,
	    int do5d,
	    Real mass,
	    Real M5,int Ncg,Real residual[],int max_iter[]);

template 
int dwf_CG<float,float>
          (LatticePropagator &sol, 
	   LatticePropagator &src,
	   multi1d<LatticeColorMatrix> &U,
	   std::string output_stem,
	   int Ls,
	   int do5d,
	   Real mass,
	   Real M5,int Ncg,Real residual[],int max_iter[]);


