#ifndef _BFM_COMM_QMP_BAGEL2_H_
#define _BFM_COMM_QMP_BAGEL2_H_

template <class Float>
class commQMPbagel2 : public bfmbagel2<Float> { 
public:

  // QMP thingy-me-bob's
  QMP_msghandle_t multi_handle[2];

  QMP_msgmem_t send_ops_msgmem_t[8];
  QMP_msgmem_t recv_ops_msgmem_t[8];

  QMP_msghandle_t send_multi_handle;
  QMP_msghandle_t send_handles[8];


  QMP_msghandle_t recv_handles[8];
  QMP_msghandle_t all_handles;

  // Buffers
  Float *sendbufs[8];
  Float *recvbufs[8];

  int num_op;

  virtual bool isBoss() ;

  void gather(int result_cb, Fermion_t psi,int dag) ; 

  virtual void comm_init(void) ;
  virtual void comm_end(void) ;
  virtual void recv_init(Fermion_t psi);
  virtual void recv_end(void) ;
  virtual void comm(int result_cb, Fermion_t psi,int dag) ;
  virtual void comm_start(int result_cb, Fermion_t psi,int dag) ;
  virtual void comm_qmp_start(Fermion_t psi) ;
  virtual void comm_qmp_complete(void) ;
  virtual void comm_complete(int result_cb, Fermion_t psi) ;
  virtual void comm_gsum(double &val) ;

  void scatter(int result_cb, Fermion_t psi) ; 
};
#endif
